"""
Django settings for gooshichand project.

Generated by 'django-admin startproject' using Django 1.11.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os
import sys

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = False
WINDOWS_ENV = False

ALLOWED_HOSTS = [u'gooshichand.ir', u'www.gooshichand.com', u'gooshichand.com', '127.0.0.1', '10.0.2.2',
                 '104.171.124.113', u'tourbeen.ir', u'www.tourbeen.ir']


# Application definition

INSTALLED_APPS = [
    'grappelli',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'watson',
    'rest_framework.authtoken',
    'gooshichand',
    'website',
    'tours',
    'android',
    'socialmedia',
    'backup',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'gooshichand.middleware.SendExceptionMiddleware',
    'backup.middleware.FilterIPMiddleware'
]

ROOT_URLCONF = 'gooshichand.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'gooshichand.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'gooshichand',
        'USER': 'gooshichandmehran',
        'PASSWORD': 'morgan_v23',
        'HOST': '104.171.124.113',
        'PORT': '5432',
    }
}
MONGO_IP = '127.0.0.1'
MONGO_PORT = 27017
# if 'test' in sys.argv:  # Covers regular testing and django-coverage
#     DATABASES['default']['ENGINE'] = 'django.db.backends.sqlite3'
if 'python.exe' in sys.executable:  # Covers regular testing and django-coverage
    WINDOWS_ENV = True
    DEBUG = True
    MONGO_IP = '104.171.124.113'
    MONGO_PORT = 27017

# CELERY STUFF
CACHE_TTL = 60 * 15
BROKER_URL = 'redis://localhost:6379'
CELERY_RESULT_BACKEND = 'redis://localhost:6379'
CELERY_ACCEPT_CONTENT = ['application/json']
CELERY_TASK_SERIALIZER = 'json'
CELERY_RESULT_SERIALIZER = 'json'
CELERY_TIMEZONE = 'Asia/Tehran'

CACHES = {
    'default': {
        'BACKEND': 'django_redis.cache.RedisCache',
        'LOCATION': 'redis://localhost:6379/',
        'OPTIONS': {
            'CLIENT_CLASS': 'django_redis.client.DefaultClient',
        }
    }
}
if 'python.exe' in sys.executable:  # Covers regular testing and django-coverage
    BROKER_URL = 'redis://104.171.124.113:6379'
    CELERY_RESULT_BACKEND = 'redis://104.171.124.113:6379'
    CACHES['default']['LOCATION'] = 'redis://104.171.124.113:6379/'

TESTING = 'test' in sys.argv[1:]
if TESTING:
    print('=========================')
    print('In TEST Mode - Disableling Migrations')
    print('=========================')

    class DisableMigrations(object):

        def __contains__(self, item):
            return True

        def __getitem__(self, item):
            return None

    MIGRATION_MODULES = DisableMigrations()

# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Tehran'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, "static/")

MEDIA_URL = '/static/website/'
MEDIA_ROOT = os.path.join(BASE_DIR, 'static/website/')
STATICFILES_DIRS = (
    os.path.join(BASE_DIR, 'staticfiles'),
)

PAGINATION_SIZE = 21

TELEGRAM_TOKEN = "595255997:AAHcV-leW1X0vksOv-l2lu0kQQC9H6oee8w"

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'obbme0vo@(x0jtzeb=adf8obv_9z5#ol%%pa=8fc%85lbuvpw^'

MAILGUN_API_KEY = "key-003388ab49c27836a3c7e7161aaa30bc"

LOGIN_URL = '/admin/login/'
